//
// Copyright (C) 1999-2004 Toshikaz Hirabayashi
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// TOSHIKAZ HIRABAYASHI BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.
//
// Except as contained in this notice, the name of Toshikaz Hirabayashi shall
// not be used in advertising or otherwise to promote the sale, use or other
// dealings in this Software without prior written authorization from
// Toshikaz Hirabayashi.

#include <WScom.h>
#include <WSDexternal.h>

WSMFclassInit(WSDexternal,WSCroot);

WSDexternal* (*WSDexternal::_chandler)() = NULL;

WSDexternal::~WSDexternal(){}
WSDexternal* WSDexternal::getNewInstance(){
  if (_chandler == NULL){
    return new WSDexternal();
  }
  return _chandler();
}

void* WSDexternal::_tmp = 0;
void WSDexternal::setTempData(void* data){
  _tmp = data;
}
void* WSDexternal::getTempData(){
  return _tmp;
}

void WSDexternal::setCreateInstanceHandler(void* hd){
  _chandler = (WSDexternal* (*)())hd;
}

long WSDexternal::open(char*){
WSMFtrace("WSDexternal Warring. This system does not support open().\n");
  return WS_ERR;
}

long WSDexternal::close(){
WSMFtrace("WSDexternal Warring. This system does not support close().\n");
  return WS_ERR;
}

WSCstring* WSDexternal::getObjectSymbols(){
WSMFtrace("WSDexternal Warring. This system does not support getObjectSymbols().\n");
  return NULL;
}
char* WSDexternal::getName(){
  return _dll_name.getString();
}
char* WSDexternal::_prj_name = NULL;
char* WSDexternal::getProjectName(){
  if (_prj_name == NULL){
    return "";
  }
  return _prj_name;
}
void WSDexternal::setProjectName(char* pname){
  _prj_name = pname;
}

